#!/usr/bin/env python

import distutils
import distutils.sysconfig

from distutils.command.build import build
from distutils.core import setup
from DistUtilsExtra.command import *
from string import Template

from recent_notifications.Globals import VERSION, WEBSITE

class update_prefix(distutils.cmd.Command):
  description = "substitute $PREFIX with the current prefix"

  user_options = [
      ("files=", None, ".in files that should be updated")
  ]

  def initialize_options(self):
    self.files = "[]"

  def finalize_options(self):
    pass

  def run(self):
    try:
      file_set = eval(self.files)
    except:
      raise Exception("Invalid files option: " + self.files)

    for file in file_set:
      if file.endswith(".in"):
        output_file = file[:-3]
      else:
        raise Exception("Invalid file: " + file)

      print "updating PREFIX in file", output_file

      with open(file, "r") as f:
        server_data = f.read()

      with open(output_file, "w") as f:
        f.write(Template(server_data).safe_substitute(PREFIX=distutils.sysconfig.PREFIX))

build.sub_commands.append(("update_prefix", None))

setup(
    name="recent-notifications",
    version=VERSION,
    author="Jason Conti",
    author_email="jason.conti@gmail.com",
    url=WEBSITE,
    license="GNU General Public License (GPL)",
    packages=["recent_notifications"],
    data_files=[
        ("lib/recent-notifications", ["recent-notifications"]),
        ("share/icons/hicolor/scalable/apps", ["icons/recent-notifications.svg"]),
        ("share/icons/hicolor/scalable/status", [
            "icons/notification-critical.svg",
            "icons/notification-low.svg",
            "icons/notification-normal.svg",
            "icons/humanity-notification-read.svg",
            "icons/humanity-notification-unread.svg",
            "icons/notification-read.svg",
            "icons/notification-unread.svg"])
    ],
    cmdclass={
      "build": build_extra.build_extra,
      "build_i18n": build_i18n.build_i18n,
      "update_prefix": update_prefix
    }
)

