"""
test-appindicator.py
August 16, 2010
"""

import appindicator
import gtk

from recent_notifications.Notification import Notification

main_menu = None
indicator = None
message_items = []

def on_message_received(monitor, message):
  global main_menu
  global indicator
  if len(message_items) >= 5:
    last_item = message_items.pop()
    main_menu.remove(last_item)
    last_item.destroy()
  main_menu.prepend(gtk.SeparatorMenuItem())
  current_item = gtk.MenuItem(message.summary)
  main_menu.prepend(current_item)
  message_items.insert(0, current_item)
  main_menu.show_all()
  indicator.set_menu(main_menu)
  indicator.set_status(appindicator.STATUS_ATTENTION)

def main():
  global main_menu
  global indicator
  main_menu = gtk.Menu()
  default_item = gtk.MenuItem("Show Message Window")
  main_menu.add(default_item)
  main_menu.show_all()
  main_menu.set_take_focus(False)
  indicator = appindicator.Indicator("test", "humanity-notification-read", appindicator.CATEGORY_OTHER)
  indicator.set_attention_icon("humanity-notification-unread")
  indicator.set_status(appindicator.STATUS_ACTIVE)
  indicator.set_menu(main_menu)
  notify = Notification()
  notify.connect("message-received", on_message_received)
  gtk.main()

if __name__ == '__main__':
  main()
